unit DlgOpenEx;

{**********************************************************************}
{                                                                      }
{   DlgExOpen                                                          }
{                                                                      }
{   extended open dialog                                               }
{                                                                      }
{   Version     v0.96/12.05.05                                         }
{   Copyright   (c) 2003 by DiK                                        }
{                                                                      }
{   NB: this only works when NOT using packages                        }
{                                                                      }
{**********************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TTseOpenDialog = class(TOpenDialog)
  private
    FButtonPanel: TPanel;
    FBinaryButton: TCheckBox;
    function GetCtrlRect(Ctrl: THandle): TRect;
    function GetAsBinary: Boolean;
    procedure SetAsBinary(const Value: Boolean);
  protected
    function GetComCtrlRect(ID: Integer): TRect;
    function GetTextRect: TRect;
    procedure DoShow; override;
  public
    constructor Create(AOwner: TComponent); override;
    function Execute: Boolean; override;
    property AsBinary: Boolean read GetAsBinary write SetAsBinary;
  end;

{**********************************************************************}
{   implementation                                                     }
{**********************************************************************}

implementation

uses
  Dlgs;

{$R DikOpenDlgTemplate.RES}

{----------------------------------------------------------------------}

constructor TTseOpenDialog.Create(AOwner: TComponent);
begin
  inherited;
  FButtonPanel := TPanel.Create(Self);
  with FButtonPanel do
  begin
    Name := 'ButtonPanel';
    Caption := '';
    SetBounds(0, 0, 316, 76);
    BevelOuter := bvNone;
    BorderWidth := 0;
    TabOrder := 1;
    FBinaryButton := TCheckBox.Create(Self);
    with FBinaryButton do
    begin
      Name := 'BinaryButton';
      Caption := 'Open As Binary';
      SetBounds(0, 0, 157, 23);
      Parent := FButtonPanel;
    end;
  end;
end;

function TTseOpenDialog.GetCtrlRect(Ctrl: THandle): TRect;
begin
  if Handle <> 0 then
  begin
    if not (ofOldStyleDialog in Options) then
    begin
      GetWindowRect(Ctrl, Result);
      MapWindowPoints(0, Handle, Result, 2);
    end
    else GetClientRect(Handle, Result)
  end
  else Result := Rect(0,0,0,0);
end;

function TTseOpenDialog.GetComCtrlRect(ID: Integer): TRect;
begin
  Result := GetCtrlRect(GetDlgItem(GetParent(Handle), ID));
end;

function TTseOpenDialog.GetTextRect: TRect;
begin
  Result := GetCtrlRect(GetDlgItem(Handle, 101));
end;

procedure TTseOpenDialog.DoShow;
var
  PanelRect, TempRect: TRect;
begin
  GetClientRect(Handle, PanelRect);
  TempRect := GetComCtrlRect(cmb1);
  PanelRect.Left := TempRect.Left;
  TempRect := GetTextRect;
  PanelRect.Top := TempRect.Top;
  FButtonPanel.BoundsRect := PanelRect;
  FButtonPanel.ParentWindow := Handle;
  inherited;
end;

function TTseOpenDialog.GetAsBinary: Boolean;
begin
  Result := FBinaryButton.Checked;
end;

procedure TTseOpenDialog.SetAsBinary(const Value: Boolean);
begin
  FBinaryButton.Checked := Value;
end;

function TTseOpenDialog.Execute: Boolean;
begin
  if NewStyleControls and not (ofOldStyleDialog in Options) then
    Template := 'DIKOPENDLGTEMPLATE' else
    Template := nil;
  Result := inherited Execute;
end;

end.
