unit FormBuffers;

{**********************************************************************}
{                                                                      }
{   FormBuffers                                                        }
{                                                                      }
{   the buffer list                                                    }
{                                                                      }
{   Version     v0.96/12.05.05                                         }
{   Copyright   (c) 2003-2005 by DiK                                   }
{                                                                      }
{**********************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, StdCtrls,
  IncrSrch, Common, FormStrList, Menus;

type
  TFrmBuffers = class(TFrmStrList)
    BtnList: TButton;
    BtnOpen: TButton;
    BtnSave: TButton;
    BtnRemove: TButton;
    procedure LstBoxKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure BtnListClick(Sender: TObject);
    procedure BtnOpenClick(Sender: TObject);
    procedure BtnSaveClick(Sender: TObject);
    procedure BtnRemoveClick(Sender: TObject);
  end;

function WinDlgBuffers(
  ID: Integer; Selected: PSalStr; MaxLen: Integer): Integer; stdcall;

{**********************************************************************}
{   implementation                                                     }
{**********************************************************************}

implementation

uses
  FormMsgBox;

resourcestring
  rsCloseEditor = 'This will terminate the editor! Countinue?';

{$R *.dfm}

{----------------------------------------------------------------------}

function WinDlgBuffers(
  ID: Integer; Selected: PSalStr; MaxLen: Integer): Integer;
var
  S: string;
  Form: TFrmBuffers;
begin
  Form := TFrmBuffers.Create(nil);
  try
    try
      with Form do
      begin
        GetStrList(ID);
        with LstBox do
          if Items.Count > 0 then
            ItemIndex := 0;
        Result := Execute;
        with LstBox do
          if ItemIndex <> -1 then
            S := Items[ItemIndex]
          else
            S := '';
        SetSalStr(Selected, MaxLen, S);
        SetStrList(ID);
      end;
    except
      Result := Form.LastError;
    end;
  finally
    Form.Free;
  end;
end;

{----------------------------------------------------------------------}

procedure TFrmBuffers.LstBoxKeyDown(
  Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_DELETE then BtnRemove.Click;
end;

{----------------------------------------------------------------------}

procedure TFrmBuffers.BtnListClick(Sender: TObject);
begin
  ModalResult := idList;
end;

procedure TFrmBuffers.BtnOpenClick(Sender: TObject);
begin
  ModalResult := idOpen;
end;

procedure TFrmBuffers.BtnSaveClick(Sender: TObject);
begin
  ModalResult := idSave;
end;

procedure TFrmBuffers.BtnRemoveClick(Sender: TObject);
begin
  if (LstBox.Items.Count > 1) or (DlgMsgBox(Caption, rsCloseEditor) = idOK) then
    ModalResult := idRemove;
end;

end.
