unit FormComp;

{**********************************************************************}
{                                                                      }
{   FormComp                                                           }
{                                                                      }
{   input device for file comparison                                   }
{                                                                      }
{   Version     v0.96/12.05.05                                         }
{   Copyright   (c) 2003-2005 by DiK                                   }
{                                                                      }
{**********************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms,
  Common, FormDlgs, Menus, StdCtrls, Buttons, Dialogs;

type
  TFrmComp = class(TFrmDlgs)
    OpenDialog: TOpenDialog;
    Label1: TLabel;
    Label2: TLabel;
    CmbFile1: TComboBox;
    CmbFile2: TComboBox;
    BtnFile1: TBitBtn;
    BtnFile2: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure BtnSearchClick(Sender: TObject);
    procedure BtnFile1Click(Sender: TObject);
    procedure BtnFile2Click(Sender: TObject);
  private
    fFile1: TStrings;
    fFile2: TStrings;
  end;

function WinDlgComp(ID1, ID2: Integer): Integer; stdcall;

{**********************************************************************}
{   implementation                                                     }
{**********************************************************************}

implementation

{$R *.dfm}

{----------------------------------------------------------------------}

function WinDlgComp(ID1, ID2: Integer): Integer;
var
  Form: TFrmComp;
begin
  Form := TFrmComp.Create(nil);
  try
    try
      with Form do
      begin
        fFile1 := ValidateStrings(ID1);
        fFile2 := ValidateStrings(ID2);
        Result := Execute;
      end;
    except
      Result := Form.LastError;
    end;
  finally
    Form.Free;
  end;
end;

{----------------------------------------------------------------------}

procedure TFrmComp.FormShow(Sender: TObject);
begin
  InitComboBox(CmbFile1, fFile1);
  InitComboBox(CmbFile2, fFile2);
end;

procedure TFrmComp.FormHide(Sender: TObject);
begin
  fFile1.Insert(0, CmbFile1.Text);
  fFile2.Insert(0, CmbFile2.Text);
end;

{----------------------------------------------------------------------}

procedure TFrmComp.BtnSearchClick(Sender: TObject);
begin
  ModalResult := idOpen;
end;

procedure TFrmComp.BtnFile1Click(Sender: TObject);
begin
  if OpenDialog.Execute then CmbFile1.Text := OpenDialog.FileName;
  CmbFile1.SetFocus;
end;

procedure TFrmComp.BtnFile2Click(Sender: TObject);
begin
  if OpenDialog.Execute then CmbFile2.Text := OpenDialog.FileName;
  CmbFile2.SetFocus;
end;

end.
