unit FormGoto;

{**********************************************************************}
{                                                                      }
{   FormGoto                                                           }
{                                                                      }
{   goto line and column dialog                                        }
{                                                                      }
{   Version     v0.96/12.05.05                                         }
{   Copyright   (c) 2003-2005 by DiK                                   }
{                                                                      }
{**********************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, StdCtrls,
  FormDlgs, Common, Menus;

type
  TFrmGoto = class(TFrmDlgs)
    LblLine: TLabel;
    LblCol: TLabel;
    CmbLine: TComboBox;
    CmbCol: TComboBox;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure CmbLineKeyPress(Sender: TObject; var Key: Char);
  private
    fLineList: TStrings;
    fColList: TStrings;
  public
    procedure SetLineList(ID: Integer);
    procedure SetColList(ID: Integer);
  end;

function WinDlgGoto(LineHist, ColHist: Integer): Integer; stdcall;

{**********************************************************************}
{   implementation                                                     }
{**********************************************************************}

implementation

{$R *.dfm}

{----------------------------------------------------------------------}

function WinDlgGoto(LineHist, ColHist: Integer): Integer;
var
  Form: TFrmGoto;
begin
  Form := TFrmGoto.Create(nil);
  try
    try
      with Form do
      begin
        SetLineList(LineHist);
        SetColList(ColHist);
        Result := Execute;
      end;
    except
      Result := Form.LastError;
    end;
  finally
    Form.Free;
  end;
end;

{----------------------------------------------------------------------}

procedure TFrmGoto.SetLineList(ID: Integer);
begin
  fLineList := ValidateStrings(ID);
end;

procedure TFrmGoto.SetColList(ID: Integer);
begin
  fColList := ValidateStrings(ID);
end;

{----------------------------------------------------------------------}

procedure TFrmGoto.FormShow(Sender: TObject);
begin
  InitComboBox(CmbLine, fLineList);
  InitComboBox(CmbCol, fColList);
end;

procedure TFrmGoto.FormHide(Sender: TObject);
begin
  fLineList.Insert(0, CmbLine.Text);
  fColList.Insert(0, CmbCol.Text);
end;

{----------------------------------------------------------------------}

procedure TFrmGoto.CmbLineKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in [#8,'0'..'9']) then Key := #0;
end;

end.
