unit FormHist;

{**********************************************************************}
{                                                                      }
{   FormHist                                                           }
{                                                                      }
{   display TES's history lists                                        }
{                                                                      }
{   Version     v0.96/12.05.05                                         }
{   Copyright   (c) 2003-2005 by DiK                                   }
{                                                                      }
{**********************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Menus,
  StdCtrls, ComCtrls, FormDlgs;

type
  TFrmHist = class(TFrmDlgs)
    ListView: TListView;
    BtnDel: TButton;
    BtnUser: TButton;
    procedure ListViewChange(
      Sender: TObject; Item: TListItem; Change: TItemChange);
    procedure ListViewKeyDown(
      Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListViewDblClick(Sender: TObject);
    procedure BtnDelClick(Sender: TObject);
    procedure BtnUserClick(Sender: TObject);
  public
    procedure GetStrList(ID: Integer);
  end;

function WinDlgHistories(ID: Integer; var Selected: Integer): Integer; stdcall;

{**********************************************************************}
{   implementation                                                     }
{**********************************************************************}

implementation

uses
  Common, FormMsgBox;

{$R *.dfm}

{----------------------------------------------------------------------}

function WinDlgHistories(ID: Integer; var Selected: Integer): Integer; stdcall;
var
  Form: TFrmHist;
  Index: Integer;
begin
  Form := TFrmHist.Create(nil);
  try
    try
      with Form do
      begin
        GetStrList(ID);
        if ListView.Items.Count > 0 then
          with ListView.Items[0] do
          begin
            Selected := True;
            Focused := True;
          end;
        Result := Execute;
        Index := ListView.ItemIndex;
        if Index >= 0 then
          Selected := StrToInt(ListView.Items[Index].SubItems[0]);
      end;
    except
      Result := Form.LastError;
    end;
  finally
    Form.Free;
  end;
end;

{----------------------------------------------------------------------}

procedure TFrmHist.GetStrList(ID: Integer);
var
  Hist: TStrings;
  S: string;
  I: Integer;
begin
  Hist := ValidateStrings(ID);
  for I := 0 to Hist.Count-1 do
    with ListView.Items.Add do
    begin
      S := Hist[I];
      Caption := Tokenize(#9,S);
      SubItems.Add(Tokenize(#9,S));
      SubItems.Add(Tokenize(#9,S));
    end;
end;

{----------------------------------------------------------------------}

procedure TFrmHist.ListViewChange(
  Sender: TObject; Item: TListItem; Change: TItemChange);
var
  Sel: Boolean;
begin
  Sel := ListView.Selected <> nil;
  BtnOk.Enabled := Sel;
  BtnDel.Enabled := Sel;
end;

procedure TFrmHist.ListViewKeyDown(
  Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_DELETE) and (BtnDel.Enabled) then BtnDelClick(Sender);
end;

procedure TFrmHist.ListViewDblClick(Sender: TObject);
begin
  ModalResult := mrOK;
end;

{----------------------------------------------------------------------}

procedure TFrmHist.BtnDelClick(Sender: TObject);
begin
  if DlgMsgBox(rsWarn, rsDelAllHist) = idOK then
    ModalResult := idRemove;
end;

procedure TFrmHist.BtnUserClick(Sender: TObject);
begin
  ModalResult := idList;
end;

end.
