unit FormHistStr;

{**********************************************************************}
{                                                                      }
{   FormHistStr                                                        }
{                                                                      }
{   display contents of a history list                                 }
{                                                                      }
{   Version     v0.96/12.05.05                                         }
{   Copyright   (c) 2003-2005 by DiK                                   }
{                                                                      }
{**********************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Menus, StdCtrls,
  FormDlgs, Common;

type
  TFrmHistStr = class(TFrmDlgs)
    LstBox: TListBox;
    BtnDelAll: TButton;
    procedure BtnCancelClick(Sender: TObject);
    procedure BtnDelAllClick(Sender: TObject);
    procedure LstBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  public
    procedure GetStrList(ID: Integer);
  end;

function WinDlgHistStrings(
  ID: Integer; Title: PSalStr; var Selected: Integer): Integer; stdcall;

{**********************************************************************}
{   implementation                                                     }
{**********************************************************************}

implementation

uses
  FormMsgBox;

{$R *.dfm}

resourcestring
  rsCaption = 'Contents of History List: ';

{----------------------------------------------------------------------}

function WinDlgHistStrings(
  ID: Integer; Title: PSalStr; var Selected: Integer): Integer;
var
  Form: TFrmHistStr;
begin
  Form := TFrmHistStr.Create(nil);
  try
    try
      with Form do
      begin
        Caption := rsCaption + GetSalStr(Title);
        GetStrList(ID);
        LstBox.ItemIndex := 0;
        Result := Execute;
        Selected := LstBox.ItemIndex + 1;
      end;
    except
      Result := Form.LastError;
    end;
  finally
    Form.Free;
  end;
end;

{----------------------------------------------------------------------}

procedure TFrmHistStr.GetStrList(ID: Integer);
var
  Hist: TStrings;
begin
  Hist := ValidateStrings(ID);
  LstBox.Items.AddStrings(Hist);
end;

{----------------------------------------------------------------------}

procedure TFrmHistStr.LstBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_DELETE then BtnCancelClick(Sender);
end;

procedure TFrmHistStr.BtnCancelClick(Sender: TObject);
begin
  ModalResult := idRemove;
end;

procedure TFrmHistStr.BtnDelAllClick(Sender: TObject);
begin
  if DlgMsgBox(rsWarn, rsDelAllHist) = idOK then
    ModalResult := idRemoveAll;
end;

end.
