unit FormHistUser;

{**********************************************************************}
{                                                                      }
{   FormHistUser                                                       }
{                                                                      }
{   display TES's user histories                                       }
{                                                                      }
{   Version     v0.96/12.05.05                                         }
{   Copyright   (c) 2003-2005 by DiK                                   }
{                                                                      }
{**********************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Menus,
  StdCtrls, ComCtrls, FormHist, FormDlgs;

type
  TFrmHistUser = class(TFrmDlgs)
    ListView: TListView;
    BtnDel: TButton;
    BtnComp: TButton;
    procedure ListViewChange(
      Sender: TObject; Item: TListItem; Change: TItemChange);
    procedure ListViewKeyDown(
      Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure BtnDelClick(Sender: TObject);
    procedure BtnCompClick(Sender: TObject);
  private
    fHistList: TStrings;
  public
    procedure GetStrList(ID: Integer);
  end;

function WinDlgHistUser(ID: Integer; var Selected: Integer): Integer; stdcall;

{**********************************************************************}
{   implementation                                                     }
{**********************************************************************}

implementation

uses
  Common, FormMsgBox;

{$R *.dfm}

const
  sOrphan     = '[*** orphaned history id ***]';
resourcestring
  rsNotEmpty  = 'History list is not empty!'#13'Delete anyway?';

{----------------------------------------------------------------------}

function WinDlgHistUser(ID: Integer; var Selected: Integer): Integer; stdcall;
var
  Form: TFrmHistUser;
  Index: Integer;
begin
  Form := TFrmHistUser.Create(nil);
  try
    try
      with Form do
      begin
        GetStrList(ID);
        if ListView.Items.Count > 0 then
          with ListView.Items[0] do
          begin
            Selected := True;
            Focused := True;
          end;
        Result := Execute;
        Index := ListView.ItemIndex;
        if Index >= 0 then
          Selected := StrToInt(ListView.Items[Index].SubItems[0]);
      end;
    except
      Result := Form.LastError;
    end;
  finally
    Form.Free;
  end;
end;

{----------------------------------------------------------------------}

procedure TFrmHistUser.GetStrList(ID: Integer);
var
  S: string;
  I: Integer;
begin
  fHistList := ValidateStrings(ID);
  for I := 0 to fHistList.Count-1 do
    with ListView.Items.Add do
    begin
      S := fHistList[I];
      Data := Pointer(I);
      Caption := Tokenize(#9,S);
      SubItems.Add(Tokenize(#9,S));
      SubItems.Add(Tokenize(#9,S));
      fHistList[I] := IntToStr(I+1);
    end;
end;

{----------------------------------------------------------------------}

procedure TFrmHistUser.ListViewChange(
  Sender: TObject; Item: TListItem; Change: TItemChange);
begin
  BtnDel.Enabled := ListView.Selected <> nil;
end;

procedure TFrmHistUser.ListViewKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_DELETE) and (BtnDel.Enabled) then BtnDelClick(Sender);
end;

{----------------------------------------------------------------------}

procedure TFrmHistUser.BtnDelClick(Sender: TObject);
var
  OK: Boolean;
begin
  with ListView.Selected do
  begin
    OK := (SubItems[1] = '-') or (DlgMsgBox(rsWarn, rsNotEmpty) = idOK);
    if OK then
    begin
      Caption := sOrphan;
      SubItems[1] := '-';
      fHistList[Integer(Data)] := '';
    end;
  end;
end;

procedure TFrmHistUser.BtnCompClick(Sender: TObject);
var
  S: string;
  I: Integer;
begin
  I := 0;
  while I < ListView.Items.Count do
  begin
    with ListView.Items[I] do
      if Caption = sOrphan then
      begin
        fHistList[Integer(Data)] := '';
        Delete;
      end else
      begin
        Inc(I);                 // inc before assign
        S := IntToStr(I);       // because ID is 1 based
        SubItems[0] := S;
        fHistList[Integer(Data)] := S;
      end;
  end;
end;

end.
