unit FormInpBox;

{**********************************************************************}
{                                                                      }
{   FormMessage                                                        }
{                                                                      }
{   basic text input box                                               }
{                                                                      }
{   Version     v0.96/12.05.05                                         }
{   Copyright   (c) 2003-2005 by DiK                                   }
{                                                                      }
{**********************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, StdCtrls,
  FormDlgs, Common, Menus;

type
  TFrmInpBox = class(TFrmDlgs)
    LblMsg: TLabel;
    CmbText: TComboBox;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    fHistList: TStrings;
  public
    procedure SetHistList(ID: Integer);
  end;

function DlgInpBox(
  Title, MsgText: string; HistID: Integer; DoPopup: Boolean = False): Integer;

function WinDlgInpBox(
  Title, MsgText: PSalStr; HistID: Integer): Integer; stdcall;

function WinDlgInpBoxEx(
  Title, MsgText: PSalStr; HistID: Integer): Integer; stdcall;

{**********************************************************************}
{   implementation                                                     }
{**********************************************************************}

implementation

{$R *.dfm}

{----------------------------------------------------------------------}

procedure TFrmInpBox.SetHistList(ID: Integer);
begin
  fHistList := ValidateStrings(ID);
end;

procedure TFrmInpBox.FormShow(Sender: TObject);
begin
  InitComboBox(CmbText, fHistList);
end;

procedure TFrmInpBox.FormHide(Sender: TObject);
begin
  fHistList.Insert(0, CmbText.Text);
end;

{----------------------------------------------------------------------}

function DlgInpBox(
  Title, MsgText: string; HistID: Integer; DoPopup: Boolean): Integer;
var
  Form: TFrmInpBox;
begin
  Form := TFrmInpBox.Create(nil);
  try
    try
      with Form do
      begin
        Caption := Title;
        LblMsg.Caption := MsgText;
        SetHistList(HistID);
        if DoPopup then
        begin
          CmbText.PopupMenu := MenuEdit;
          CmbText.OnContextPopup := FormContextPopup;
        end;
        Result := Execute;
      end;
    except
      Result := Form.LastError;
    end;
  finally
    Form.Free;
  end;
end;

{----------------------------------------------------------------------}

function WinDlgInpBox(Title, MsgText: PSalStr; HistID: Integer): Integer;
begin
  Result := DlgInpBox(GetSalStr(Title), GetSalStr(MsgText), HistID);
end;

{----------------------------------------------------------------------}

function WinDlgInpBoxEx(Title, MsgText: PSalStr; HistID: Integer): Integer;
begin
  Result := DlgInpBox(GetSalStr(Title), GetSalStr(MsgText), HistID, True);
end;

end.
