unit FormMCC;

{**********************************************************************}
{                                                                      }
{   FormMCC                                                            }
{                                                                      }
{   macro control center                                               }
{                                                                      }
{   Version     v0.96/12.05.05                                         }
{   Copyright   (c) 2003-2005 by DiK                                   }
{                                                                      }
{**********************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, StdCtrls,
  FormDlgs, Menus;

type
  TFrmMCC = class(TFrmDlgs)
    GrpNames: TGroupBox;
    CmbMacro: TComboBox;
    GrpList: TGroupBox;
    LstMacros: TListBox;
    BtnSearch: TButton;
    BtnLoad: TButton;
    BtnPurge: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure LstMacrosClick(Sender: TObject);
    procedure LstMacrosDblClick(Sender: TObject);
    procedure BtnSearchClick(Sender: TObject);
    procedure BtnLoadClick(Sender: TObject);
    procedure BtnPurgeClick(Sender: TObject);
  private
    LastIndex: Integer;
    fMacroList: TStrings;
    fMacroHist: TStrings;
  public
    procedure SetMacroList(ID: Integer);
    procedure SetMacroHist(ID: Integer);
  end;

function WinDlgMCC(MacroList, MacroHist: Integer): Integer; stdcall;

{**********************************************************************}
{   implementation                                                     }
{**********************************************************************}

implementation

uses
  Common;

{$R *.dfm}

{----------------------------------------------------------------------}

function WinDlgMCC(MacroList, MacroHist: Integer): Integer;
var
  Form: TFrmMCC;
begin
  Form := TFrmMCC.Create(nil);
  try
    try
      with Form do
      begin
        SetMacroList(MacroList);
        SetMacroHist(MacroHist);
        Result := Execute;
      end;
    except
      Result := Form.LastError;
    end;
  finally
    Form.Free;
  end;
end;

{----------------------------------------------------------------------}

procedure TFrmMCC.SetMacroList(ID: Integer);
begin
  fMacroList := ValidateStrings(ID);
end;

procedure TFrmMCC.SetMacroHist(ID: Integer);
begin
  fMacroHist := ValidateStrings(ID);
end;

{----------------------------------------------------------------------}

procedure TFrmMCC.FormShow(Sender: TObject);
begin
  LastIndex := -1;
  InitComboBox(CmbMacro, fMacroHist);
  LstMacros.Items.AddStrings(fMacroList);
end;

procedure TFrmMCC.FormHide(Sender: TObject);
begin
  fMacroHist.Insert(0, CmbMacro.Text);
end;

{----------------------------------------------------------------------}

procedure TFrmMCC.LstMacrosClick(Sender: TObject);
begin
  LastIndex := LstMacros.ItemIndex;
  if LastIndex >= 0 then CmbMacro.Text := LstMacros.Items[LastIndex];
end;

procedure TFrmMCC.LstMacrosDblClick(Sender: TObject);
begin
  if LastIndex >= 0 then ModalResult := idOk;
end;

{----------------------------------------------------------------------}

procedure TFrmMCC.BtnSearchClick(Sender: TObject);
begin
  ModalResult := idOpen;
end;

procedure TFrmMCC.BtnLoadClick(Sender: TObject);
begin
  ModalResult := idLoad;
end;

procedure TFrmMCC.BtnPurgeClick(Sender: TObject);
begin
  ModalResult := idRemove;
end;

end.
