unit FormRecent;

{**********************************************************************}
{                                                                      }
{   FormRecent                                                         }
{                                                                      }
{   the recent files list                                              }
{                                                                      }
{   Version     v0.96/12.05.05                                         }
{   Copyright   (c) 2003-2005 by DiK                                   }
{                                                                      }
{**********************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, StdCtrls,
  IncrSrch, Common, FormBuffers, Menus;

type
  TFrmRecent = class(TFrmBuffers)
    BtnClean: TButton;
    procedure BtnRemoveClick(Sender: TObject);
    procedure BtnCleanClick(Sender: TObject);
    procedure BtnSaveClick(Sender: TObject);
  end;

function WinDlgRecent(
  ID: Integer; Selected: PSalStr; MaxLen: Integer): Integer; stdcall;

{**********************************************************************}
{   implementation                                                     }
{**********************************************************************}

implementation

uses
  FormMsgBox;

resourcestring
  rsRemoveAll = 'Remove all recent file items?';

{$R *.dfm}

{----------------------------------------------------------------------}

function WinDlgRecent(
  ID: Integer; Selected: PSalStr; MaxLen: Integer): Integer;
var
  S: string;
  Form: TFrmRecent;
begin
  Form := TFrmRecent.Create(nil);
  try
    try
      with Form do
      begin
        GetStrList(ID);
        case LstBox.Items.Count of
          0:    ; // NOP
          1:    LstBox.ItemIndex := 0;
          else  LstBox.ItemIndex := 1;
        end;
        Result := Execute;
        with LstBox do
          if ItemIndex <> -1 then
            S := Items[ItemIndex]
          else
            S := '';
        SetSalStr(Selected, MaxLen, S);
        SetStrList(ID);
      end;
    except
      Result := Form.LastError;
    end;
  finally
    Form.Free;
  end;
end;

{----------------------------------------------------------------------}

procedure TFrmRecent.BtnRemoveClick(Sender: TObject);
begin
  LstBox.DeleteSelected;
end;

procedure TFrmRecent.BtnCleanClick(Sender: TObject);
var
  I: Integer;
begin
  for I := LstBox.Items.Count-1 downto 0 do
    if not FileExists(LstBox.Items[I]) then
      LstBox.Items.Delete(I);
end;

procedure TFrmRecent.BtnSaveClick(Sender: TObject);
begin
  if DlgMsgBox(Caption, rsRemoveAll) = idOK then
  begin
    LstBox.Clear;
    Close;
  end;
end;

end.
