unit FormReplace;

{**********************************************************************}
{                                                                      }
{   FormReplace                                                        }
{                                                                      }
{   find dialog                                                        }
{                                                                      }
{   Version     v0.96/12.05.05                                         }
{   Copyright   (c) 2003-2005 by DiK                                   }
{                                                                      }
{**********************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, StdCtrls,
  FormFind, Menus, ExtCtrls;

type
  TFrmReplace = class(TFrmFind)
    LblReplace: TLabel;
    CmbReplace: TComboBox;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    fRplcList: TStrings;
  protected
    function GetOptions: string; override;
    procedure SetOptions(Opts: string); override;
  public
    procedure SetRplcList(ID: Integer);
  end;

function WinDlgReplace(
  FindHist, ReplaceHist, ReplaceOptsHist: Integer): Integer; stdcall;

{**********************************************************************}
{   implementation                                                     }
{**********************************************************************}

implementation

{$R *.dfm}

{----------------------------------------------------------------------}

function WinDlgReplace(
  FindHist, ReplaceHist, ReplaceOptsHist: Integer): Integer;
var
  Form: TFrmReplace;
begin
  Form := TFrmReplace.Create(nil);
  try
    try
      with Form do
      begin
        SetFindList(FindHist);
        SetRplcList(ReplaceHist);
        SetOptsList(ReplaceOptsHist);
        Result := Execute;
      end;
    except
      Result := Form.LastError;
    end;
  finally
    Form.Free;
  end;
end;

{----------------------------------------------------------------------}

procedure TFrmReplace.SetRplcList(ID: Integer);
begin
  fRplcList := ValidateStrings(ID);
end;

{----------------------------------------------------------------------}

function TFrmReplace.GetOptions: string;
var
  N: Integer;
begin
  Result := inherited GetOptions;
  N := Pos('v', Result);
  if N > 0 then Result[N] := 'n';
end;

procedure TFrmReplace.SetOptions(Opts: string);
begin
  inherited;
  ChkView.Checked := Pos('n', Opts) > 0;
end;

{----------------------------------------------------------------------}

procedure TFrmReplace.FormShow(Sender: TObject);
begin
  inherited;
  CmbReplace.Items.AddStrings(fRplcList);
  if fRplcList.Count > 0 then CmbReplace.Text := fRplcList[0];
end;

procedure TFrmReplace.FormHide(Sender: TObject);
begin
  inherited;
  fRplcList.Insert(0, CmbReplace.Text);
end;

end.
