unit FormStrList;

{**********************************************************************}
{                                                                      }
{   FormStrList                                                        }
{                                                                      }
{   display a list of strings                                          }
{                                                                      }
{   Version     v0.96/12.05.05                                         }
{   Copyright   (c) 2003-2005 by DiK                                   }
{                                                                      }
{**********************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, StdCtrls, Menus,
  IncrSrch, FormDlgs;

type
  TFrmStrList = class(TFrmDlgs)
    IncrSearch: TListBoxIncrSearch;
    LstBox: TListBox;
    procedure FormShow(Sender: TObject);
    procedure LstBoxDblClick(Sender: TObject);
    procedure IncrSearchActivate(Sender: TObject);
    procedure IncrSearchDeactivate(Sender: TObject);
    procedure IncrSearchTextChanged(Sender: TObject);
  private
    fTitle: TCaption;
    fStrList: TStrings;
  public
    procedure GetStrList(ID: Integer);
    procedure SetStrList(ID: Integer);
  end;

function WinDlgStrList(ID: Integer): Integer; stdcall;

{**********************************************************************}
{   implementation                                                     }
{**********************************************************************}

implementation

uses
  StrList, Common;

resourcestring
  rsIncSearch = 'Searching for: ';

{$R *.dfm}

{----------------------------------------------------------------------}

function WinDlgStrList(ID: Integer): Integer;
var
  Form: TFrmStrList;
begin
  Form := TFrmStrList.Create(nil);
  try
    try
      with Form do
      begin
        GetStrList(ID);
        Result := Execute;
      end;
    except
      Result := Form.LastError;
    end;
  finally
    Form.Free;
  end;
end;

{----------------------------------------------------------------------}

procedure TFrmStrList.FormShow(Sender: TObject);
var
  I, L, M: Integer;
  TM: TTextMetric;
  FC: TControlCanvas;
begin
  M := 0;
  for I := 0 to LstBox.Items.Count-1 do
  begin
    L := Length(LstBox.Items[I]);
    if L > M then M := L;
  end;
  FC := TControlCanvas.Create;
  try
    FC.Control := LstBox;
    GetTextMetrics(FC.Handle, TM);
  finally
    FC.Free;
  end;
  LstBox.ScrollWidth := M * TM.tmAveCharWidth;
end;

procedure TFrmStrList.LstBoxDblClick(Sender: TObject);
begin
  ModalResult := mrOK;
end;

procedure TFrmStrList.IncrSearchActivate(Sender: TObject);
begin
  fTitle := Caption;
  BtnCancel.Cancel := False;
end;

procedure TFrmStrList.IncrSearchDeactivate(Sender: TObject);
begin
  Caption := fTitle;
  BtnCancel.Cancel := True;
end;

procedure TFrmStrList.IncrSearchTextChanged(Sender: TObject);
begin
  Caption := rsIncSearch + IncrSearch.SearchText;
end;

{----------------------------------------------------------------------}

procedure TFrmStrList.GetStrList(ID: Integer);
begin
  fStrList := ValidateStrings(ID);
  LstBox.Items.AddStrings(fStrList);
end;

procedure TFrmStrList.SetStrList(ID: Integer);
begin
  fStrList.Clear;
  fStrList.AddStrings(LstBox.Items);
end;

end.
