unit FormTodo;

{**********************************************************************}
{                                                                      }
{   FormTodo                                                           }
{                                                                      }
{   add or edit a todo item                                            }
{                                                                      }
{   Version     v0.96/12.05.05                                         }
{   Copyright   (c) 2003-2005 by DiK                                   }
{                                                                      }
{**********************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Menus, StdCtrls,
  FormDlgs, Common, ComCtrls;

type
  TFrmAddTodo = class(TFrmDlgs)
    LblText: TLabel;
    MemoText: TMemo;
    LblPriority: TLabel;
    EdtPriority: TEdit;
    UpDnPriority: TUpDown;
    LblOwner: TLabel;
    EdtOwner: TEdit;
    LblCategory: TLabel;
    EdtCategory: TEdit;
    procedure MemoTextKeyDown(
      Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    TextList: TStrings;
  public
    procedure GetControls(var S: string);
    procedure SetControls(ID: Integer; S: string);
  end;

function WinDlgAddTodo(DataID: Integer;
  Args: PSalStr; MaxArgs: Integer): Integer; stdcall;

{**********************************************************************}
{   implementation                                                     }
{**********************************************************************}

implementation

{$R *.dfm}

{----------------------------------------------------------------------}

function WinDlgAddTodo(DataID: Integer;
  Args: PSalStr; MaxArgs: Integer): Integer;
var
  S: string;
  Form: TFrmAddTodo;
begin
  Form := TFrmAddTodo.Create(nil);
  try
    try
      with Form do
      begin
        SetControls(DataID, GetSalStr(Args));
        Result := Execute;
        GetControls(S);
        SetSalStr(Args, MaxArgs, S);
      end;
    except
      Result := Form.LastError;
    end;
  finally
    Form.Free;
  end;
end;

{----------------------------------------------------------------------}

procedure TFrmAddTodo.GetControls(var S: string);
begin
  S := IntToStr(UpDnPriority.Position) + #9 + EdtOwner.Text + #9 + EdtCategory.Text;
  TextList.Assign(MemoText.Lines);
end;

procedure TFrmAddTodo.SetControls(ID: Integer; S: string);
begin
  UpDnPriority.Position := StrToInt(Tokenize(#9,S));
  EdtOwner.Text := Tokenize(#9,S);
  EdtCategory.Text := Tokenize(#9,S);
  TextList := ValidateStrings(ID);
  MemoText.Lines.Assign(TextList);
  MemoText.SelStart := 0;
end;

{----------------------------------------------------------------------}

procedure TFrmAddTodo.MemoTextKeyDown(
  Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then ModalResult := mrCancel;
end;

end.
