unit FormTodoSetup;

{**********************************************************************}
{                                                                      }
{   FormTodo                                                           }
{                                                                      }
{   setup dialog for todo defaults                                     }
{                                                                      }
{   Version     v0.96/12.05.05                                         }
{   Copyright   (c) 2003-2005 by DiK                                   }
{                                                                      }
{**********************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Menus, StdCtrls,
  Common, FormDlgs, ComCtrls;

type
  TFrmTodoSetup = class(TFrmDlgs)
    GrpDefComment: TGroupBox;
    LblCmt: TLabel;
    EdtCmt: TEdit;
    GrpParams: TGroupBox;
    LblPrior: TLabel;
    EdtPrior: TEdit;
    UpDnPrior: TUpDown;
    LblOwner: TLabel;
    EdtOwner: TEdit;
    LblCateg: TLabel;
    EdtCateg: TEdit;
  public
    procedure GetControls(var S: string);
    procedure SetControls(S: string);
  end;

function WinDlgTodoSetup(Args: PSalStr; MaxArgs: Integer): Integer; stdcall;

{**********************************************************************}
{   implementation                                                     }
{**********************************************************************}

implementation

{$R *.dfm}

{----------------------------------------------------------------------}

function WinDlgTodoSetup(Args: PSalStr; MaxArgs: Integer): Integer;
var
  S: string;
  Form: TFrmTodoSetup;
begin
  Form := TFrmTodoSetup.Create(nil);
  try
    try
      with Form do
      begin
        SetControls(GetSalStr(Args));
        Result := Execute;
        GetControls(S);
        SetSalStr(Args, MaxArgs, S);
      end;
    except
      Result := Form.LastError;
    end;
  finally
    Form.Free;
  end;
end;

{----------------------------------------------------------------------}

procedure TFrmTodoSetup.GetControls(var S: string);
begin
  S := EdtCmt.Text + #9 +
    IntToStr(UpDnPrior.Position) + #9 + EdtOwner.Text + #9 + EdtCateg.Text;
end;

procedure TFrmTodoSetup.SetControls(S: string);
begin
  EdtCmt.Text := Tokenize(#9,S);
  UpDnPrior.Position := StrToInt(Tokenize(#9,S));
  EdtOwner.Text := Tokenize(#9,S);
  EdtCateg.Text := Tokenize(#9,S);
end;

end.
