{======================================================================}
{                                                                      }
{   include Switches                                  Version 1.0      }
{                                                                      }
{   standard definition of all compiler switches                       }
{                                                                      }
{   History                                                            }
{   v1.09/16.09.02  delphi 7                                           }
{   v1.08/21.12.01  definition info off                                }
{   v1.07/29.07.01  delphi 6                                           }
{   v1.06/20.10.99  delphi 5                                           }
{   v1.05/09.02.99  reference info on                                  }
{   v1.04/04.11.98  version defines                                    }
{   v1.03/24.08.98  delphi 4                                           }
{   v1.02/23.09.97  minor changes                                      }
{   v1.01/16.06.97  delphi 3                                           }
{   v1.00/13.01.97  first version                                      }
{                                                                      }
{======================================================================}

{======================================================================}
{   version defines                                                    }
{======================================================================}

{$IFDEF VER90}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI2}
{$ELSE}{$IFDEF VER95}
  {$DEFINE CBUILDER}
  {$DEFINE DELPHI2}
{$ELSE}{$IFDEF VER100}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI2}
  {$DEFINE DELPHI3}
{$ELSE}{$IFDEF VER110}
  {$DEFINE CBUILDER}
  {$DEFINE DELPHI2}
  {$DEFINE DELPHI3}
{$ELSE}{$IFDEF VER120}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI2}
  {$DEFINE DELPHI3}
  {$DEFINE DELPHI4}
{$ELSE}{$IFDEF VER125}
  {$DEFINE CBUILDER}
  {$DEFINE DELPHI2}
  {$DEFINE DELPHI3}
  {$DEFINE DELPHI4}
{$ELSE}{$IFDEF VER130}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI2}
  {$DEFINE DELPHI3}
  {$DEFINE DELPHI4}
  {$DEFINE DELPHI5}
{$ELSE}{$IFDEF VER140}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI2}
  {$DEFINE DELPHI3}
  {$DEFINE DELPHI4}
  {$DEFINE DELPHI5}
  {$DEFINE DELPHI6}
{$ELSE}{$IFDEF VER150}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI2}
  {$DEFINE DELPHI3}
  {$DEFINE DELPHI4}
  {$DEFINE DELPHI5}
  {$DEFINE DELPHI6}
  {$DEFINE DELPHI7}
{$ELSE}
  ! Invalid Version
{$ENDIF}{$ENDIF}{$ENDIF}{$ENDIF}{$ENDIF}{$ENDIF}{$ENDIF}{$ENDIF}{$ENDIF}

{======================================================================}
{   hints and warnings                                                 }
{======================================================================}

{$IFDEF NOHINTS}
  {$HINTS                     OFF     -}
  {$WARNINGS                  OFF     -}

{$ELSE}
  {$HINTS                     ON      -}
  {$WARNINGS                  ON      -}

  {$IFDEF DELPHI6}{$IFDEF WIN32}
    {$WARN SYMBOL_PLATFORM    OFF     -}
    {$WARN UNIT_PLATFORM      OFF     -}
  {$ENDIF}{$ENDIF}

  {$IFDEF DELPHI7}{$IFDEF WIN32}
    {$WARN UNSAFE_CODE        OFF     -}
    {$WARN UNSAFE_TYPE        OFF     -}
    {$WARN UNSAFE_CAST        OFF     -}
  {$ENDIF}{$ENDIF}

{$ENDIF}

{======================================================================}
{   standard switches                                                  }
{======================================================================}

{$BOOLEVAL                    OFF     B}
{$EXTENDEDSYNTAX              ON      X}
{$IOCHECKS                    ON      I}
{$LONGSTRINGS                 ON      H}
{$MINENUMSIZE                 1       Z}
{$OPENSTRINGS                 ON      P}
{$SAFEDIVIDE                  OFF     U}
{$STACKFRAMES                 OFF     W}
{$TYPEDADDRESS                ON      T}
{$WRITEABLECONST              OFF     J}

{$IFDEF DELPHI4}
  {$REALCOMPATIBILITY         OFF     -}
{$ENDIF}

{$IFNDEF DELPHI6}
  {$ALIGN                     ON      A}
{$ENDIF}

{======================================================================}
{   debug switches                                                     }
{======================================================================}

{$REFERENCEINFO               ON      Y}

//{$IFDEF DELPHI4}
//  {$DEFINITIONINFO            ON      YD}
//{$ENDIF}

{$IFDEF DEBUG}
  {$DEBUGINFO                 ON      D}
  {$LOCALSYMBOLS              ON      L}
  {$OPTIMIZATION              OFF     O}
{$ELSE}
  {$DEBUGINFO                 OFF     D}
  {$LOCALSYMBOLS              OFF     L}
  {$OPTIMIZATION              ON      O}
{$ENDIF}

{======================================================================}
{   code checking                                                      }
{======================================================================}

{$IFDEF CHECK}
  {$IFDEF DELPHI3}
    {$ASSERTIONS              ON      C}
  {$ENDIF}
  {$IFNDEF DELPHI7}
    {$STACKCHECKS             ON      S}
  {$ENDIF}
  {$OVERFLOWCHECKS            ON      Q}
  {$RANGECHECKS               ON      R}
  {$VARSTRINGCHECKS           ON      V}
{$ELSE}
  {$IFDEF DELPHI3}
    {$ASSERTIONS              OFF     C}
  {$ENDIF}
  {$IFNDEF DELPHI7}
    {$STACKCHECKS             OFF     S}
  {$ENDIF}
  {$OVERFLOWCHECKS            OFF     Q}
  {$RANGECHECKS               OFF     R}
  {$VARSTRINGCHECKS           OFF     V}
{$ENDIF}

{======================================================================}
{   the end                                                            }
{======================================================================}

